'''
cd ~/.local/share/applications/
cat puma.desktop
[Desktop Entry]
Name=Puma
NoDisplay=true
Exec=/usr/bin/python3 /home/elettra/tmp/lz/launcher.py %u
Type=Application

xdg-mime default puma.desktop x-scheme-handler/puma
'''
import subprocess
import sys
import psutil
import socket
import time
host = socket.gethostname()
import urllib.request

if len(sys.argv)<2:
    sys.exit('Error: missing executable name')

argv = ' '.join(sys.argv).replace('%20', ' ').split(' ')
argv[1] = argv[1].replace('puma://', '')
feedback = "http://puma-01.elettra.eu/knob/index.php?host="+host+"&pid="

with open('/home/elettra/tmp/lz/launcher_'+host+'.log', 'a') as mylog:
        # mylog.write(process_name+' '+' '.join(params)+"\n")
        mylog.write(time.strftime("%Y-%m-%d %H:%M:%S ")+' '.join(argv)+"\n")
        mylog.flush()

# Path to the executable
executable_path = ('/runtime/bin/'+argv[1]).replace('/bin/elettra/', '/elettra/bin/')

def is_process_running(process_name, params):
    """Check if a process with the given name and parameters is running."""
    for proc in psutil.process_iter(['name', 'cmdline']):
        try:
            # Check if the process name matches
            if proc.info['name'] == process_name:
                # Check if the command line arguments match
                if params == proc.info['cmdline'][1:]:  # Skip the first element (the executable name)
                    return True
        except (psutil.NoSuchProcess, psutil.AccessDenied, psutil.ZombieProcess):
            pass
    return False

process_name = argv[1].replace('elettra/', '')
params = argv[2:]

if is_process_running(process_name, params):
        print(f"The process '{process_name}' with parameters {params} is already running.")
        argv[1] = executable_path
        print('/usr/bin/python3 /home/elettra/tmp/lz/vibration.py '+' '.join(argv[1:]))
        processInfo = subprocess.Popen('/usr/bin/python3 /home/elettra/tmp/lz/vibration.py '+' '.join(argv[1:]), shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        print(processInfo.stdout.read())
        f = urllib.request.urlopen(feedback+'0')
        myfile = f.read()
else:
        print(f"The process '{process_name}' with parameters {params} is not running.")
        try:
                argv[1] = executable_path
                process = subprocess.Popen(argv[1:])
                pid = process.pid
                print(f"The PID of the launched process is: {pid}")
                f = urllib.request.urlopen(feedback+str(pid))
                myfile = f.read()
                #print(myfile)

        except Exception as e:
                print(e)
                f = urllib.request.urlopen(feedback+'-1&err='+str(e))
                myfile = f.read()
                #print(myfile)

